/*
 * 
 */
package InnoM.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class InnoMVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "MExampleEncodingProblem.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID.equals(view
					.getType())) {
				return InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return InnoM.diagram.part.InnoMVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance()
						.logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (InnoM.InnoMPackage.eINSTANCE.getINNO().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((InnoM.INNO) domainElement)) {
			return InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = InnoM.diagram.part.InnoMVisualIDRegistry
				.getModelID(containerView);
		if (!InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID
				.equals(containerModelID) && !"InnoM".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = InnoM.diagram.part.InnoMVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
			if (InnoM.InnoMPackage.eINSTANCE.getLeadership().isSuperTypeOf(
					domainElement.eClass())) {
				return InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID;
			}
			break;
		case InnoM.diagram.edit.parts.LeadershipLeadershipProtagonistCompartmentEditPart.VISUAL_ID:
			if (InnoM.InnoMPackage.eINSTANCE.getProtagonist().isSuperTypeOf(
					domainElement.eClass())) {
				return InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID;
			}
			break;
		case InnoM.diagram.edit.parts.LeadershipLeadershipCeoCompartmentEditPart.VISUAL_ID:
			if (InnoM.InnoMPackage.eINSTANCE.getCEO().isSuperTypeOf(
					domainElement.eClass())) {
				return InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID;
			}
			break;
		case InnoM.diagram.edit.parts.CEOCEOCeoFactorCompartmentEditPart.VISUAL_ID:
			if (InnoM.InnoMPackage.eINSTANCE.getCEOFactor().isSuperTypeOf(
					domainElement.eClass())) {
				return InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = InnoM.diagram.part.InnoMVisualIDRegistry
				.getModelID(containerView);
		if (!InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID
				.equals(containerModelID) && !"InnoM".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = InnoM.diagram.part.InnoMVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.LeadershipNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InnoM.diagram.edit.parts.LeadershipLeadershipProtagonistCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InnoM.diagram.edit.parts.LeadershipLeadershipCeoCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.ProtagonistNamepProtagonistEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.CEONameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InnoM.diagram.edit.parts.CEOCEOCeoFactorCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.CEOFactorNameCeoCeoFactorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.LeadershipLeadershipProtagonistCompartmentEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.LeadershipLeadershipCeoCompartmentEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.CEOCEOCeoFactorCompartmentEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InnoM.diagram.edit.parts.IsAAutoLinkEditPart.VISUAL_ID:
			if (InnoM.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(InnoM.INNO element) {
		return true;
	}

}
