/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package InnoM.impl;

import InnoM.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class InnoMFactoryImpl extends EFactoryImpl implements InnoMFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static InnoMFactory init()
  {
    try
    {
      InnoMFactory theInnoMFactory = (InnoMFactory)EPackage.Registry.INSTANCE.getEFactory("INNO"); 
      if (theInnoMFactory != null)
      {
        return theInnoMFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new InnoMFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InnoMFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case InnoMPackage.INNO: return createINNO();
      case InnoMPackage.LEADERSHIP: return createLeadership();
      case InnoMPackage.PROTAGONIST: return createProtagonist();
      case InnoMPackage.CEO: return createCEO();
      case InnoMPackage.CEO_FACTOR: return createCEOFactor();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case InnoMPackage.PROTAGONISTS:
        return createProtagonistsFromString(eDataType, initialValue);
      case InnoMPackage.CEO_FACTORS:
        return createCEOFactorsFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case InnoMPackage.PROTAGONISTS:
        return convertProtagonistsToString(eDataType, instanceValue);
      case InnoMPackage.CEO_FACTORS:
        return convertCEOFactorsToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public INNO createINNO()
  {
    INNOImpl inno = new INNOImpl();
    return inno;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Leadership createLeadership()
  {
    LeadershipImpl leadership = new LeadershipImpl();
    return leadership;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Protagonist createProtagonist()
  {
    ProtagonistImpl protagonist = new ProtagonistImpl();
    return protagonist;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CEO createCEO()
  {
    CEOImpl ceo = new CEOImpl();
    return ceo;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CEOFactor createCEOFactor()
  {
    CEOFactorImpl ceoFactor = new CEOFactorImpl();
    return ceoFactor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Protagonists createProtagonistsFromString(EDataType eDataType, String initialValue)
  {
    Protagonists result = Protagonists.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertProtagonistsToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public CEOFactors createCEOFactorsFromString(EDataType eDataType, String initialValue)
  {
    CEOFactors result = CEOFactors.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertCEOFactorsToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InnoMPackage getInnoMPackage()
  {
    return (InnoMPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static InnoMPackage getPackage()
  {
    return InnoMPackage.eINSTANCE;
  }

} //InnoMFactoryImpl
